HelpBot Assistant

How can I help you?

Syncfusion® EJ2 JavaScript Controls - Security

6 Feb 20269 minutes to read

Security is a critical aspect of web applications to protect them from various threats and vulnerabilities. Using HTTPS for data encryption, validating and sanitizing user inputs, and implementing strong authentication measures such as multi-factor authentication are indispensable practices in Web application development.

Syncfusion® JavaScript controls are implemented with these security considerations.

Security Vulnerabilities

Security vulnerabilities in web applications refer to weaknesses or flaws in the design, implementation, or configuration that can be exploited by attackers to compromise the application’s integrity, confidentiality, or availability. The following are some common vulnerabilities.

  • Cross-Site Scripting (XSS) - A security vulnerability that can occur in web applications. These scripts can steal session cookies, redirect users to malicious websites, or deface the website. XSS vulnerabilities typically arise when the application fails to properly validate or encode user-supplied input before rendering it in the browser.

  • Cross-Site Request Forgery (CSRF) - A type of web security vulnerability that allows an attacker to force a logged-in user to perform actions on a web application without their consent or knowledge. CSRF attacks exploit the trust that a web application has in the user’s browser by tricking it into sending unauthorized requests to the vulnerable application.

  • Injection Attacks - These occur when an attacker injects malicious code (such as SQL injection, XML injection, or command injection) into input fields or parameters of a web application. If the application does not properly sanitize or validate user inputs, it can execute unintended commands or gain unauthorized access to sensitive data.

Syncfusion® JavaScript controls provide support for implementing web applications with enhanced security features.

Security Considerations

Security holds significant importance in software development, and the incorporation of security measures from the outset of the development process is vital for the protection of applications. Syncfusion® takes a thorough approach to security in the development of JavaScript controls, encompassing all critical aspects. The following considerations provide a comprehensive overview of security measures.

Content Security Policy

Content Security Policy (CSP) is a one of the security feature, that helps the detect the cross-site-scripting(XSS) attacks and malicious code injection. It will throw the errors and warnings while using the inline-styles and inline scripts, eval, new Function, etc in your applications.

To implement Content Security Policy (CSP) in your application, include a <meta> tag with specified CSP directives. Syncfusion® JavaScript controls have been designed and implemented with adherence to these CSP directives, ensuring enhanced security. These directives are below.

CSP Directives

The following directives are Essential® for utilizing Syncfusion® JavaScript Controls.

Directives Description Examples
style-src Defines the allowed sources for loading stylesheets. This helps mitigate style-based attacks by restricting the locations from which styles can be applied. style-src 'self' https://cdn.syncfusion.com/ https://fonts.googleapis.com/ 'unsafe-inline';
font-src Defines the allowed sources for loading fonts. It helps prevent font-related security issues by restricting the locations from which fonts can be loaded. font-src 'self' https://fonts.googleapis.com/ https://fonts.gstatic.com/ data: cdn.syncfusion.com 'unsafe-inline';
img-src Specifies the allowed sources for loading images. It helps control from where images can be displayed on the web page. img-src 'self' data:"

Utilizing a web worker within the Spreadsheet Control for exporting necessitates the addition of a specific directive to ensure proper functionality during the export process.
worker-src 'self' 'unsafe-inline' * blob:;

CSP Sources

The following sources refer to the origins from which resources such as styles, images, and fonts are allowed to be loaded and executed on a web page.

Source Description Examples
self Refers to the origin from which the protected document is being served, including the same URL scheme and port number style-src 'self'
data Enables a website to fetch resources using the data scheme, such as loading Base64-encoded images. img-src 'self' data:
unsafe-inline Allows the use of inline resources, such as inline style elements. style-src 'self' https://fonts.googleapis.com/ 'unsafe-inline'

To know more information about the CSP, refer this documentation.

HTML Sanitizer

An HTML sanitizer is a tool or program that helps remove potentially malicious or harmful code from HTML documents. This type of sanitizer is commonly used in web applications to prevent cross-site scripting (XSS) attacks, which can inject malicious code into a website and compromise user data. HTML sanitizers typically work by analyzing HTML code and removing any potentially dangerous or unwanted elements, such as script tags, inline styles, or event handlers. Other aspects of the HTML may also be modified or cleaned up, such as removing extra whitespace or fixing malformed code.

To avoid the risk of code injection, Syncfusion® has provided the enableHtmlSanitizer API into its UI controls. This ensures that HTML strings submitted by users are sanitized, enhancing security measures against potential threats.

When this property is enabled, the HTML string undergoes a thorough sanitization process before being rendered in the component. This approach ensures that user inputs containing potential security threats are meticulously filtered, addressing the risk of XSS and contributing to the overall security robustness of our components in the face of potential attacks.

To sanitize input values in a web application using Syncfusion® sanitizer, you can use the following code.

import { SanitizeHtmlHelper } from '@syncfusion/ej2-base';

let html: string = '<script>alert("XSS");</script>';

let sanitizedHtml: string = SanitizeHtmlHelper.sanitize(html);

For sanitizing the template content using Syncfusion® JavaScript controls, please see the provided code below.

import { Dialog } from '@syncfusion/ej2-popups';
import { SanitizeHtmlHelper } from '@syncfusion/ej2-base';

let dialog: Dialog = new Dialog({ 
  header: SanitizeHtmlHelper.sanitize( 
      '<div id="dlg-template" title="Nancy" class="e-icon-settings"> Nancy </div><div onmousemove=function(){alert("XSS")}>XSS</div>') 
  });
var tooltip = new ej.popups.Tooltip({
    enableHtmlSanitizer: true,
    content: "<img src=text onerror=alert(`XSS_Script_Attack`) \/>" 
});
tooltip.appendTo('#target');

var button = new ej.buttons.Button({
    content: 'Hover me for a tooltip!',
});
button.appendTo('#target');
<!DOCTYPE html>
<html lang="en">
<head>        
    <title>EJ2 Grid</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Grid Control">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.1.44/material.css" rel="stylesheet">
    <script src="es5-datasource.js"></script>
<script src="https://cdn.syncfusion.com/ej2/33.1.44/dist/ej2.min.js" type="text/javascript"></script>
</head>
<body>
    <div id='container'>
        <div style="display: inline-block; position: relative; left: 50%;top: 100px;transform: translateX(-50%);">
            <span id='target'></span>
        </div>
    </div>

<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

When enableHtmlSanitizer is true, the content will be sanitized and displays the code.

With sanitizer property

When enableHtmlSanitizer is false or not included this property, the malicious code will be interpreted as script, and the alert pop-up window will be open.

Without sanitizer property

Function Template

Users can customize the control’s appearance and functionality to suit their application’s specific needs through template support. Syncfusion® JavaScript controls has Function Template support that accept one or more UI segments as input and can be rendered as part of the controls during control rendering. For more information, you can refer this documentation.

Browser Storage

Browser storage refers to the mechanisms provided by web browsers to store data locally on a user’s device. Syncfusion® JavaScript controls utilize the following storage options only.

  • Local Storage

Local Storage

Local Storage is a type of web storage mechanism provided by web browsers that allows web applications to store data locally on a user’s device. It provides a simple key-value pair storage interface and is accessible via JavaScript.

Syncfusion® JavaScript controls utilize local storage only when persistence is enabled.

Syncfusion AI Assistant

How can I help you?

Syncfusion® React components - Security

10 Mar 20267 minutes to read

Security is critical in web applications. Best practices include using HTTPS, validating and sanitizing user input, and enforcing strong authentication such as multi-factor authentication.

Syncfusion® React components incorporate these security considerations to support secure, production-ready applications.

Security Vulnerabilities

Web application security vulnerabilities are weaknesses in design, implementation, or configuration that may be exploited to compromise data integrity, confidentiality, or availability. Syncfusion® React components are designed to help mitigate common vulnerabilities, including:

  • Cross-Site Scripting (XSS) – XSS occurs when user-supplied input is rendered without proper validation or encoding. Malicious scripts can be executed in the user’s browser, leading to session hijacking, redirection to malicious sites, or unauthorized actions.
  • Cross-Site Request Forgery (CSRF) – CSRF tricks authenticated users into executing unintended actions on a web application. This exploits the trust the site has in the user’s browser by sending unauthorized requests without the user’s knowledge.
  • Injection Attacks – These involve injecting malicious code (such as SQL injection, XML injection, or command injection) through input fields or parameters. Proper input validation and parameterized queries are essential to prevent unauthorized execution of commands or access to sensitive data.

Security Considerations

Incorporating security measures from the outset of development is vital for protecting applications. Syncfusion® employs a rigorous approach to security in its React components. The following considerations provide an overview of key security measures:

Content Security Policy

Content Security Policy (CSP) is a security feature that detects and mitigates Cross-Site Scripting (XSS) and data injection attacks. It reports errors and warnings when inline styles, inline scripts, eval, or new Function are used in unauthorized ways.

To implement CSP, include a <meta> tag with specified CSP directives. Syncfusion® React components generally adhere to strict CSP directives, though specific features may require certain allowances.

CSP Directives

The following directives are relevant when using Syncfusion® React components:

Directives Description Examples
style-src Defines allowed sources for stylesheets. style-src 'self' https://cdn.syncfusion.com/ https://fonts.googleapis.com/ 'unsafe-inline';
font-src Defines allowed sources for fonts. font-src 'self' https://fonts.googleapis.com/ https://fonts.gstatic.com/ data: cdn.syncfusion.com;
img-src Specifies allowed sources for images. img-src 'self' data:;

Note: Using a web worker within the Spreadsheet component for exporting requires the following directive:
worker-src 'self' 'unsafe-inline' * blob:;

CSP Sources

The following sources define permitted origins for resources:

Source Description Examples
self Refers to the origin from which the protected document is served (same protocol, host, and port). style-src 'self'
data Allows resources via the data scheme (e.g., Base64-encoded images). img-src 'self' data:
unsafe-inline Permits inline resources, such as inline <style> or <script> elements. style-src 'self' 'unsafe-inline'

For more details on configuring CSP with Syncfusion components, refer to the Content Security Policy troubleshooting guide.

HTML Sanitizer

An HTML sanitizer removes potentially malicious code from HTML strings to prevent XSS attacks. It parses HTML and strips dangerous elements like <script> tags, inline event handlers (e.g., onclick, onmouseover), and javascript URIs.

Some Syncfusion® components expose an enableHtmlSanitizer property that automatically sanitizes HTML strings before rendering; confirm availability in the specific component’s API reference. Enabling this property filters user-submitted content that may contain XSS threats.

When enableHtmlSanitizer is enabled, the HTML string is processed to remove unsafe content, helping to prevent XSS in component templates or content.

You can also manually sanitize input values using the Syncfusion® SanitizeHtmlHelper:

import { SanitizeHtmlHelper } from '@syncfusion/ej2-base';

let html = '<script>alert("XSS");</script>';
let sanitizedHtml = SanitizeHtmlHelper.sanitize(html);

The following example demonstrates sanitizing template content in a React component:

import { DialogComponent } from '@syncfusion/ej2-react-popups';
import * as React from 'react';
import { SanitizeHtmlHelper } from '@syncfusion/ej2-base';

function App() {
  return (
    <div className="App" id="dialog-target">
      <DialogComponent
        width="250px"
        // Manually sanitizing the header content
        header={SanitizeHtmlHelper.sanitize('<div id="dlg-template" title="Nancy" class="e-icon-settings"> Nancy <div onmousemove="alert(\'XSS\')">Hover me (XSS trigger removed)</div></div>')}
        target="#dialog-target"
        showCloseIcon={true}
        enableHtmlSanitizer={true} // Enables sanitization for the dialog content
      >
        This is a dialog with a sanitized header.
      </DialogComponent>
    </div>
  );
}
export default App;
import * as React from 'react';
import * as ReactDom from 'react-dom';
import { TooltipComponent } from '@syncfusion/ej2-react-popups';

function App() {
    return (<div id="container">
      <TooltipComponent position="TopCenter"
        content='<img src=text onerror=alert("XSS_Script_Attack") \/>'
        target="#target"
        enableHtmlSanitizer= {true}>
        <button className="e-btn tooltipElement" id="target" >Hover me for a tooltip!</button>
      </TooltipComponent>
    </div>);
}
export default App;
ReactDom.render(<App />, document.getElementById('sample'));
import * as React from 'react';
import * as ReactDom from 'react-dom';
import { TooltipComponent } from '@syncfusion/ej2-react-popups';

function App() {
    return (<div id="container">
      <TooltipComponent position="TopCenter"
        content='<img src=text onerror=alert("XSS_Script_Attack") \/>'
        target="#target"
        enableHtmlSanitizer= {true}>
        <button className="e-btn tooltipElement" id="target" >Hover me for a tooltip!</button>
      </TooltipComponent>
    </div>);
}
export default App;
ReactDom.render(<App />, document.getElementById('sample'));

Result with enableHtmlSanitizer={true}:
The malicious code is removed, and the content is rendered safely.

With sanitizer property

Result with enableHtmlSanitizer={false}:
The malicious code is executed (e.g., script runs, alerts appear).

Without sanitizer property

Browser Storage

Browser storage allows web applications to store data locally on a user’s device. Syncfusion® React components utilize Local Storage for specific features.

Local Storage

Local Storage stores key-value pairs in a web browser with no expiration time. Syncfusion® React components use local storage only when the persistence feature is explicitly enabled (e.g., enablePersistence={true}). This is typically used to retain component state (like Grid column sorting or filter settings) across page reloads.

HelpBot Assistant

How can I help you?

Syncfusion® Angular Components - Security

2 Feb 20267 minutes to read

Security is a critical concern in modern web application development. Key practices include enforcing HTTPS, validating and sanitizing all user inputs, implementing strong authentication and authorization, and protecting against common vulnerabilities such as XSS, CSRF, and injection attacks.

Syncfusion® Angular components are designed with security in mind and integrate seamlessly with Angular’s built-in security mechanisms, such as automatic sanitization of interpolated values and protection against common client-side attacks.

For more details on Angular’s security model, refer to the official documentation: Security in Angular

Common Security Vulnerabilities

Web applications can be exposed to various vulnerabilities if not properly secured. The following are some of the most prevalent threats:

  • Cross-Site Scripting - XSS is a security vulnerability that can occur in web applications. These scripts can steal session cookies, redirect users to malicious websites, or deface the website. XSS vulnerabilities typically arise when the application fails to properly validate or encode user-supplied input before rendering it in the browser.

  • Cross-Site Request Forgery - CSRF is a type of web security vulnerability that allows an attacker to force a logged-in user to perform actions on a web application without their consent or knowledge. CSRF attacks exploit the trust that a web application has in the user’s browser by tricking it into sending unauthorized requests to the vulnerable application.

  • Injection Attacks
    Includes SQL injection, command injection, and others where untrusted input is passed to interpreters without sanitization, potentially allowing unauthorized data access or code execution.

Syncfusion® Angular components help mitigate these risks through built-in safeguards, sanitization features, and compliance with modern security standards.

Security Features and Considerations

Syncfusion® follows secure development practices when building Angular components. Key security-related features include:

Content Security Policy (CSP) Compliance

Content Security Policy (CSP) is a browser security layer that helps detect and mitigate cross-site scripting (XSS) and data injection attacks. It restricts the sources from which resources (scripts, styles, fonts, images, etc.) can be loaded and blocks unsafe practices such as inline scripts, inline styles, eval(), and new Function().

Syncfusion® has taken significant steps to ensure that all EJ2 components are fully CSP-compliant. This means that our components no longer rely on practices that violate CSP directives, such as embedding inline styles or scripts. Instead, we have adopted secure coding practices that align with CSP standards, ensuring that our components can be seamlessly integrated into applications with strict CSP policies.

Our Document Editor product offers robust support for a strict Content Security Policy (CSP) to enhance security by preventing unauthorized content from being executed. While most features comply with strict CSP settings, there is one notable exception related to custom fonts. The setCustomFonts method is incompatible with strict CSP settings. Therefore, when enforcing a strict CSP, setCustomFonts may not function as expected.

Benefits of CSP Compliance in Syncfusion® EJ2 Components

  1. Enhanced Security: By eliminating the use of unsafe practices, Syncfusion® EJ2 components reduce the risk of XSS attacks and other client-side vulnerabilities.

  2. Seamless Integration: Developers can use Syncfusion® Angular components in applications with strict CSP configurations without requiring additional adjustments or exceptions.

  3. Future-Proof Design: Adhering to CSP standards ensures compatibility with modern web security requirements, making Syncfusion® components a reliable choice for secure application development.

  4. No Additional Configuration: Since Syncfusion® EJ2 components are CSP-compliant by design, developers do not need to include specific CSP directives or modify their existing policies to accommodate our components.

By adhering to CSP standards, Syncfusion® components provide a robust foundation for building secure and scalable web applications. This ensures that your applications are not only protected against common vulnerabilities but also meet the highest security standards.

To know more information about the CSP, refer this documentation.

CSP Directives

The following directives are commonly required when using Syncfusion® Angular components:

Directives Description Examples
font-src Defines the allowed sources for loading fonts. It helps prevent font-related security issues by restricting the locations from which fonts can be loaded. font-src 'self' https://fonts.googleapis.com/ https://fonts.gstatic.com/ data: cdn.syncfusion.com 'unsafe-inline';
img-src Specifies the allowed sources for loading images. It helps control from where images can be displayed on the web page. img-src 'self' data:"

Utilizing a web worker within the Spreadsheet Control for exporting necessitates the addition of a specific directive to ensure proper functionality during the export process.
worker-src 'self' 'unsafe-inline' * blob:;

Allowed CSP Sources

The following sources refer to the origins from which resources such as styles, images and fonts are allowed to be loaded and executed on a web page.

Source Description Examples
self Refers to the origin from which the protected document is being served, including the same URL scheme and port number style-src 'self'
data Enables a website to fetch resources using the data scheme, such as loading Base64-encoded images. img-src 'self' data:

Note: While using the PDF Viewer component for standalone components, you need to use unsafe-eval to avoid CSP issues. The PDF Viewer component is not yet converted to be fully CSP-compliant.

HTML Sanitizer

An HTML sanitizer removes potentially harmful code from HTML documents, preventing XSS attacks by eliminating malicious code like script tags or inline styles.

Syncfusion® ensures security by offering the enableHtmlSanitizer API. It sanitizes HTML strings, reducing potential threats.

The enableHtmlSanitizer property, when enabled, ensures content undergoes rigorous sanitization to mitigate XSS risks, strengthening component security.

Here is a sample code to sanitize input values using Syncfusion®:

import { SanitizeHtmlHelper } from '@syncfusion/ej2-base';

let html: string = '<script>alert("XSS");</script>';

let sanitizedHtml: string = SanitizeHtmlHelper.sanitize(html);

When enableHtmlSanitizer is true, the content will be sanitized and displays the code.

With sanitizer property

When enableHtmlSanitizer is false or not included this property, the malicious code will be interpreted as script, and the alert pop-up window will be open.

Without sanitizer property

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { TooltipModule } from '@syncfusion/ej2-angular-popups'
import { ButtonModule } from '@syncfusion/ej2-angular-buttons'


 
import { Component, ViewEncapsulation } from '@angular/core';
import { Droppable } from  '@syncfusion/ej2-base';

@Component({
imports: [
        
        TooltipModule,
        ButtonModule
    ],


standalone: true,
    selector: 'app-root',
    template: `
    <div id='container' style="display: inline-block; position: relative; left: 50%;top: 100px;transform: translateX(-50%);">
        <ejs-tooltip id='tooltip' content='<img src=text onerror=alert("XSS_Script_Attack") \/>' target="#target">
            <button ejs-button id="target">Hover me for a tooltip!</button>
        </ejs-tooltip>
    </div>`,
  encapsulation: ViewEncapsulation.None
})

export class AppComponent {
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Browser Storage

Browser storage refers to the mechanisms provided by web browsers to store data locally on a user’s device. Syncfusion® Angular components utilize the following storage options only.

  • Local Storage

Local Storage

Local Storage allows persistent data storage on client devices using key-value pairs, accessible through Angular. Syncfusion® uses local storage only when persistence is enabled.

Syncfusion AI Assistant

How can I help you?

Syncfusion® Vue Components - Security

3 Feb 20268 minutes to read

Security is a critical aspect of web applications. Using HTTPS for data encryption, validating and sanitizing user inputs, and implementing strong authentication measures (such as multi-factor authentication) are essential practices in web application development.

Syncfusion® Vue components are implemented with these security considerations.

Vue also provides built-in security guidance:

Security Vulnerabilities

Security vulnerabilities are weaknesses in the design, implementation, or configuration of a web application that can be exploited by attackers. Common vulnerabilities include:

  • Cross-Site Scripting - XSS is a security vulnerability that can occur in web applications. These scripts can steal session cookies, redirect users to malicious websites, or deface the website. XSS vulnerabilities typically arise when the application fails to properly validate or encode user-supplied input before rendering it in the browser.

  • Cross-Site Request Forgery - CSRF is a type of web security vulnerability that allows an attacker to force a logged-in user to perform actions on a web application without their consent or knowledge. CSRF attacks exploit the trust that a web application has in the user’s browser by tricking it into sending unauthorized requests to the vulnerable application.

  • Injection Attacks - These occur when an attacker injects malicious code (such as SQL injection, XML injection, or command injection) into input fields or parameters of a web application. If the application does not properly sanitize or validate user inputs, it can execute unintended commands or gain unauthorized access to sensitive data.

Syncfusion® Vue components provide support for implementing web applications with enhanced security features.

Security Considerations

Incorporating security from the start of development is vital. Syncfusion® considers several security aspects in Vue components. Key topics covered here:

Content Security Policy

Content Security Policy (CSP) is a browser security feature that helps mitigate XSS and code injection by restricting the sources of content such as scripts, styles, fonts, and images. CSP can block inline styles, inline scripts, eval, and new Function, unless explicitly allowed.

To implement CSP, include a <meta> tag or HTTP header with the required directives. Syncfusion® Vue components are designed to work with appropriate CSP directives. Some commonly required directives are shown below.

CSP Directives

The following directives are essential for utilizing Syncfusion® Vue components.

Directives Description Examples
style-src Defines the allowed sources for loading stylesheets. This helps mitigate style-based attacks by restricting the locations from which styles can be applied. style-src 'self' https://cdn.syncfusion.com/ https://fonts.googleapis.com/ 'unsafe-inline';
font-src Defines the allowed sources for loading fonts. It helps prevent font-related security issues by restricting the locations from which fonts can be loaded. font-src 'self' https://fonts.googleapis.com/ https://fonts.gstatic.com/ data: cdn.syncfusion.com 'unsafe-inline';
img-src Specifies the allowed sources for loading images. It helps control from where images can be displayed on the web page. img-src 'self' data:"

Utilizing a web worker within the Spreadsheet Control for exporting necessitates the addition of a specific directive to ensure proper functionality during the export process.
worker-src 'self' 'unsafe-inline' * blob:;

CSP Sources

The following sources refer to the origins from which resources such as styles, images, fonts are allowed to be loaded and executed on a web page.

Source Description Examples
self Refers to the origin from which the protected document is being served, including the same URL scheme and port number style-src 'self'
data Enables a website to fetch resources using the data scheme, such as loading Base64-encoded images. img-src 'self' data:
unsafe-inline Allows the use of inline resources, such as inline style elements. style-src 'self' https://fonts.googleapis.com/ 'unsafe-inline'

For more information about the CSP, refer this documentation.

HTML Sanitizer

An HTML sanitizer removes potentially dangerous content from HTML, helping prevent XSS. Syncfusion provides an HTML sanitizer utility and component-level support to sanitize user-provided HTML.

Syncfusion components expose enableHtmlSanitizer (component API) to sanitize HTML strings before rendering. When enabled, input HTML is cleaned to remove scripts and dangerous attributes.
To sanitize input values in a web application using Syncfusion® sanitizer, you can use the following code.

import { SanitizeHtmlHelper } from '@syncfusion/ej2-base';

let html: string = '<script>alert("XSS");</script>';

let sanitizedHtml: string = SanitizeHtmlHelper.sanitize(html);

For sanitizing the template content using Syncfusion® JavaScript controls, please see the provided code below.

import { DialogPlugin } from '@syncfusion/ej2-vue-popups';
import { SanitizeHtmlHelper } from '@syncfusion/ej2-base';

export default {
  name: 'App',
  components: {
    'ejs-dialog': DialogPlugin
  },
  data() {
    return {
      sanitizeHeader: ''
    };
  },
  mounted() {
    this.sanitizeHeader = SanitizeHtmlHelper.sanitize('<div id="dlg-template"  title="Nancy" class="e-icon-settings"> Nancy <div><div onmousemove=function(){alert("XSS")}>XSS</div>');
  }
};

When enableHtmlSanitizer is true, the content will be sanitized and displays the code.

With sanitizer property

When enableHtmlSanitizer is false or not included this property, the malicious code will be interpreted as script, and the alert pop-up window will be open.

Without sanitizer property

<template>
  <div id='container'>
    <ejs-tooltip class="tooltipcontainer" content='<img src=text onerror=alert("XSS_Script_Attack") \/>'
      enable-html-sanitizer="true" target="#target">
      <div style="display: inline-block; position: relative; left: 50%;top: 100px;transform: translateX(-50%);">
        <ejs-button id='target'>Hover me for a tooltip!</ejs-button>
      </div>
    </ejs-tooltip>
  </div>
</template>

<script setup>
import { TooltipComponent as EjsTooltip } from "@syncfusion/ej2-vue-popups";
import { ButtonComponent as EjsButton } from "@syncfusion/ej2-vue-buttons";
</script>

<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-buttons/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-popups/styles/material.css";
</style>
<template>
  <div id='container'>
    <ejs-tooltip class="tooltipcontainer" content='<img src=text onerror=alert("XSS_Script_Attack") \/>'
      enable-html-sanitizer="true" target="#target">
      <div style="display: inline-block; position: relative; left: 50%;top: 100px;transform: translateX(-50%);">
        <ejs-button id='target'>Hover me for a tooltip!</ejs-button>
      </div>
    </ejs-tooltip>
  </div>
</template>
  
<script>
import { TooltipComponent } from "@syncfusion/ej2-vue-popups";
import { ButtonComponent } from "@syncfusion/ej2-vue-buttons";
export default {
  name: "App",
  components: {
    "ejs-tooltip": TooltipComponent,
    "ejs-button": ButtonComponent
  }
}
</script>
  
<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-buttons/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-popups/styles/material.css";
</style>

Browser Storage

Browser storage refers to the mechanisms provided by web browsers to store data locally on a user’s device. Syncfusion® Vue components utilize the following storage options only.

  • Local Storage

Local Storage

Local Storage is a type of web storage mechanism provided by web browsers that allows web applications to store data locally on a user’s device. It provides a simple key-value pair storage interface and is accessible via Vue.

Syncfusion® Vue components utilize local storage only when persistence is enabled.